"use strict";

function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _react = _interopRequireWildcard(require("react"));
var _BarView = _interopRequireDefault(require("./bars/BarView"));
var _getBarLines = _interopRequireDefault(require("./bars/getBarLines"));
var _ChordTexts = _interopRequireDefault(require("./chords/ChordTexts"));
var _utils = require("./chords/utils");
var _Endings = _interopRequireDefault(require("./Endings"));
var _Sections = _interopRequireDefault(require("./Sections"));
var _getTimeSignature = _interopRequireDefault(require("./getTimeSignature"));
var _SvgRenderer = _interopRequireDefault(require("./SvgRenderer"));
var _Selections = _interopRequireDefault(require("./Selections"));
var _useDimensions2 = _interopRequireDefault(require("./useDimensions"));
var _useAutoScroll = _interopRequireDefault(require("./useAutoScroll"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _excluded = ["startX"];
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && Object.prototype.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t["return"] && (u = t["return"](), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
var propTypes = {
  width: _propTypes["default"].number.isRequired,
  bars: _propTypes["default"].array.isRequired,
  BarMouseUp: _propTypes["default"].func,
  BarMouseDown: _propTypes["default"].func,
  BarMouseOver: _propTypes["default"].func,
  colorSelected: _propTypes["default"].string,
  colorActive: _propTypes["default"].string,
  activeBar: _propTypes["default"].number,
  selectedBars: _propTypes["default"].array
};
var SvgChordProgression = function SvgChordProgression(props) {
  var barView = new _BarView["default"]({
    width: props.width,
    barsPerLine: 4,
    sub: 10,
    sup: 10,
    margins: {
      top: 20,
      left: 20,
      line: 30,
      right: 20
    },
    bar: {
      padding: {
        top: 25,
        left: 8
      },
      height: 40,
      repetitionLineSpace: 4
    }
  });
  // logic in constructor: it won't be updated with a render caused by receiving new props,
  // has to be updated with a 'key' prop change,
  // this is done for performance reasons
  var bars = props.bars.map(function (bar) {
    return (0, _utils.transformChords)(bar);
  }).map(function (bar, i) {
    return barView.setDimensions(bar, i);
  });
  var svg = new _SvgRenderer["default"]();
  var scale = (0, _utils.getChordTextScale)(bars, barView.bar.width);
  var chordTexts = (0, _ChordTexts["default"])(scale);
  var _chordTexts$getSvgEle = chordTexts.getSvgElems(bars, barView),
    startX = _chordTexts$getSvgEle.startX,
    chordTextsSvgElems = _objectWithoutProperties(_chordTexts$getSvgEle, _excluded);
  svg.addObject(chordTextsSvgElems);
  svg.addObject((0, _Sections["default"])(bars, barView).getSections());
  svg.addObject((0, _getBarLines["default"])(bars, barView));
  svg.addObject((0, _Endings["default"])(bars, barView).getEndings());
  svg.addTexts((0, _getTimeSignature["default"])(bars, barView));
  var barsRender = function barsRender() {
    var emptyFn = function emptyFn() {};
    var colorSelected = props.colorSelected || "#00f";
    var selectedBars = props.selectedBars || [-1, -1];
    var colorActive = props.colorActive || "#f00";
    var activeBar = props.activeBar === undefined ? -1 : props.activeBar;
    var opacity = 0.4;
    var barMouseDown = props.barMouseDown || emptyFn;
    var barMouseOver = props.barMouseOver || emptyFn;
    var barMouseUp = props.barMouseUp || emptyFn;
    var barComponents = [],
      barProps,
      isSelected,
      isCursorBar;
    var _iterator = _createForOfIteratorHelper(bars.entries()),
      _step;
    try {
      var _loop = function _loop() {
        var _step$value = _slicedToArray(_step.value, 2),
          i = _step$value[0],
          bar = _step$value[1];
        isSelected = i >= selectedBars[0] && i <= selectedBars[1];
        isCursorBar = i === activeBar;
        barProps = {
          width: barView.bar.width,
          height: barView.bar.height,
          fill: isCursorBar ? colorActive : isSelected ? colorSelected : "#fff",
          fillOpacity: isSelected || isCursorBar ? opacity : 0,
          strokeOpacity: 0,
          onMouseDown: function onMouseDown(e) {
            e.preventDefault();
            barMouseDown(i);
          },
          onMouseOver: function onMouseOver(e) {
            e.preventDefault();
            barMouseOver(i);
          },
          onMouseUp: function onMouseUp(e) {
            e.preventDefault();
            barMouseUp(i);
          }
        };
        barComponents.push(_objectSpread(_objectSpread({}, bar.dimensions), barProps));
      };
      for (_iterator.s(); !(_step = _iterator.n()).done;) {
        _loop();
      }
    } catch (err) {
      _iterator.e(err);
    } finally {
      _iterator.f();
    }
    return barComponents.map(function (props, i) {
      return /*#__PURE__*/_react["default"].createElement("rect", _extends({
        key: "bar".concat(i)
      }, props));
    });
  };
  var selectionsRender = function selectionsRender(selections) {
    if (!selections || !selections.length) return;
    var rects = _Selections["default"].getRects(bars, barView, startX, selections);
    return rects.map(function (props, i) {
      return /*#__PURE__*/_react["default"].createElement("rect", _extends({
        key: i
      }, props));
    });
  };
  var autoScrollRef = (0, _useAutoScroll["default"])(bars, props.activeBar, props.divRef);
  return /*#__PURE__*/_react["default"].createElement("svg", {
    ref: autoScrollRef,
    width: props.width,
    height: barView.getHeight(bars.length)
  }, svg.render(), barsRender(), selectionsRender(props.selections));
};
var ChordProgression = function ChordProgression(props) {
  var _useDimensions = (0, _useDimensions2["default"])(),
    divRef = _useDimensions.divRef,
    width = _useDimensions.width,
    height = _useDimensions.height;
  return /*#__PURE__*/_react["default"].createElement("div", {
    style: {
      height: height,
      overflowY: "scroll"
    },
    ref: divRef
  }, /*#__PURE__*/_react["default"].createElement(SvgChordProgression, _extends({
    divRef: divRef,
    width: width
  }, props)));
};
var _default = exports["default"] = ChordProgression;